import { Component, OnInit } from '@angular/core';
declare var html2canvas: any;
declare var AMap: any;
@Component({
  selector: 'app-test',
  templateUrl: './test.component.html',
  styleUrls: ['./test.component.scss']
})
export class TestComponent implements OnInit {

  constructor() { }
  map: any
  ngOnInit(): void {
    setTimeout(() => {
      this.map = new AMap.Map('mapxxx', {
        WebGLParams: {
          preserveDrawingBuffer: true
        }
      });

      this.map.setCity('唐山市');
    }, 0);
  }
  //生成图片
  canvasImg
  createimg() {

    // 使用html2canvas插件，将数据源中的数据转换成画布。
    html2canvas(document.querySelector("#mapxxx"), {
      useCORS: true,
      onrendered: function (canvas) {
        var dataUrl = canvas.toDataURL("image/png");
      }
    }).then(canvas => {
      // 修改生成的宽度
      // canvas.style.width = "1000px";
      console.log(canvas, "生成的画布文件");
      this.canvasImg = canvas.toDataURL("image/png");
      // console.log(this.canvasImg)
    }).then(() => {
      this.downloadFile("导出图片", this.canvasImg);

    })

  }
  downloadFile(filename, content) {
    var base64Img = content;
    var oA = document.createElement('a');
    oA.href = base64Img;
    oA.download = filename;
    var event = document.createEvent('MouseEvents');
    event.initMouseEvent('click', true, false, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
    oA.dispatchEvent(event);
  }

}
